# This file created by conda-build 3.12.0
# meta.yaml template originally from:
# C:\projects\r-ff-feedstock\recipe, last modified Fri Aug  3 06:55:39 2018
# ------------------------------------------------

package:
    name: r-ff
    version: '2.2_13'
source:
    fn: ff_2.2-13.tar.gz
    sha256: 8bfb08afe0651ef3c23aaad49208146d5f929af5af12a25262fe7743fa346ddb
    url:
        - https://cran.r-project.org/src/contrib/Archive/ff/ff_2.2-13.tar.gz
        - https://cran.r-project.org/src/contrib/ff_2.2-13.tar.gz
build:
    merge_build_host: true
    number: '1'
    rpaths:
        - lib/
        - lib/R/lib/
    string: r341hca4a3dc_1
requirements:
    build:
        - m2-base 1.0.0 2
        - m2-bash 4.3.042 5
        - m2-bash-completion 2.3 2
        - m2-catgets 1.1 3
        - m2-coreutils 8.25 102
        - m2-dash 0.5.8 2
        - m2-diffutils 3.3 4
        - m2-file 5.25 2
        - m2-filesystem 2016.04 4
        - m2-findutils 4.6.0 2
        - m2-gawk 4.1.3 2
        - m2-gcc-libs 5.3.0 4
        - m2-gettext 0.19.7 4
        - m2-gmp 6.1.0 3
        - m2-grep 2.22 4
        - m2-gzip 1.7 2
        - m2-inetutils 1.9.2 2
        - m2-info 6.0 2
        - m2-less 481 2
        - m2-libasprintf 0.19.7 4
        - m2-libbz2 1.0.6 3
        - m2-libcatgets 1.1 3
        - m2-libcrypt 1.3 2
        - m2-libgettextpo 0.19.7 4
        - m2-libiconv 1.14 3
        - m2-libintl 0.19.7 4
        - m2-liblzma 5.2.2 2
        - m2-libpcre 8.38 2
        - m2-libreadline 6.3.008 8
        - m2-libutil-linux 2.26.2 2
        - m2-libxml2 2.9.2 3
        - m2-make 4.1 5
        - m2-mintty 1!2.2.3 2
        - m2-mpfr 3.1.4 2
        - m2-msys2-launcher-git 0.3.28.860c495 2
        - m2-msys2-runtime 2.5.0.17080.65c939c 3
        - m2-ncurses 6.0.20160220 2
        - m2-sed 4.2.2 3
        - m2-tar 1.28 4
        - m2-tftp-hpa 5.2 2
        - m2-time 1.7 2
        - m2-ttyrec 1.0.8 2
        - m2-tzcode 2015.e 2
        - m2-unzip 6.0 3
        - m2-util-linux 2.26.2 2
        - m2-which 2.21 3
        - m2-zip 3.0 2
        - m2-zlib 1.2.8 4
        - m2w64-binutils 2.25.1 5
        - m2w64-bzip2 1.0.6 6
        - m2w64-crt-git 5.0.0.4636.2595836 2
        - m2w64-gcc 5.3.0 6
        - m2w64-gcc-ada 5.3.0 6
        - m2w64-gcc-fortran 5.3.0 6
        - m2w64-gcc-libgfortran 5.3.0 6
        - m2w64-gcc-libs 5.3.0 7
        - m2w64-gcc-libs-core 5.3.0 7
        - m2w64-gcc-objc 5.3.0 6
        - m2w64-gmp 6.1.0 2
        - m2w64-headers-git 5.0.0.4636.c0ad18a 2
        - m2w64-isl 0.16.1 2
        - m2w64-libiconv 1.14 6
        - m2w64-libmangle-git 5.0.0.4509.2e5a9a2 2
        - m2w64-libwinpthread-git 5.0.0.4634.697f757 2
        - m2w64-make 4.1.2351.a80a8b8 2
        - m2w64-mpc 1.0.3 3
        - m2w64-mpfr 3.1.4 4
        - m2w64-pkg-config 0.29.1 2
        - m2w64-toolchain 5.3.0 7
        - m2w64-toolchain_win-64 2.1.6 0
        - m2w64-tools-git 5.0.0.4592.90b8472 2
        - m2w64-windows-default-manifest 6.4 3
        - m2w64-winpthreads-git 5.0.0.4634.697f757 2
        - m2w64-zlib 1.2.8 10
        - msys2-conda-epoch 20160418 1
        - posix 1.0.0 2
    host:
        - m2w64-bwidget 1.9.10 2
        - m2w64-bzip2 1.0.6 6
        - m2w64-expat 2.1.1 2
        - m2w64-fftw 3.3.4 6
        - m2w64-flac 1.3.1 3
        - m2w64-gcc-libgfortran 5.3.0 6
        - m2w64-gcc-libs 5.3.0 7
        - m2w64-gcc-libs-core 5.3.0 7
        - m2w64-gettext 0.19.7 2
        - m2w64-gmp 6.1.0 2
        - m2w64-gsl 2.1 2
        - m2w64-libiconv 1.14 6
        - m2w64-libjpeg-turbo 1.4.2 3
        - m2w64-libogg 1.3.2 3
        - m2w64-libpng 1.6.21 2
        - m2w64-libsndfile 1.0.26 2
        - m2w64-libtiff 4.0.6 2
        - m2w64-libvorbis 1.3.5 2
        - m2w64-libwinpthread-git 5.0.0.4634.697f757 2
        - m2w64-libxml2 2.9.3 4
        - m2w64-mpfr 3.1.4 4
        - m2w64-pcre 8.38 2
        - m2w64-speex 1.2rc2 3
        - m2w64-speexdsp 1.2rc3 3
        - m2w64-tcl 8.6.5 3
        - m2w64-tk 8.6.5 3
        - m2w64-tktable 2.10 5
        - m2w64-wineditline 2.101 5
        - m2w64-xz 5.2.2 2
        - m2w64-zlib 1.2.8 10
        - msys2-conda-epoch 20160418 1
        - r-base 3.4.1 h8933c1f_8
        - r-bit 1.1_12 r3.4.1_0
    run:
        - m2w64-gcc-libs
        - r-base >=3.4.1,<3.4.2.0a0
        - r-bit >=1.1_12
test:
    commands:
        - '"%R%" -e "library(''ff'')"'
about:
    home: http://ff.r-forge.r-project.org/
    license: GPL-2
    license_family: GPL2
    summary: 'The ff package provides data structures that are stored on disk but
        behave (almost)

        as if they were in RAM by transparently  mapping only a section (pagesize)
        in main

        memory - the effective  virtual memory consumption per ff object. ff supports
        R''''s

        standard  atomic data types ''''double'''', ''''logical'''', ''''raw'''' and
        ''''integer'''' and  non-standard

        atomic types boolean (1 bit), quad (2 bit unsigned),  nibble (4 bit unsigned),
        byte

        (1 byte signed with NAs), ubyte (1 byte  unsigned), short (2 byte signed with
        NAs),

        ushort (2 byte unsigned),  single (4 byte float with NAs). For example ''''quad''''

        allows efficient  storage of genomic data as an ''''A'''',''''T'''',''''G'''',''''C''''
        factor.

        The unsigned  types support ''''circular'''' arithmetic. There is also support
        for  close-to-atomic

        types ''''factor'''', ''''ordered'''', ''''POSIXct'''', ''''Date'''' and  custom
        close-to-atomic

        types.  ff not only has native C-support for vectors, matrices and arrays  with

        flexible dimorder (major column-order, major row-order and  generalizations
        for

        arrays). There is also a ffdf class not unlike  data.frames and import/export
        filters

        for csv files. ff objects store raw data in binary flat files in native encoding,

        and complement this with metadata stored in R as physical and virtual attributes.

        ff objects have well-defined hybrid copying semantics,  which gives rise to
        certain

        performance improvements through  virtualization. ff objects can be stored
        and reopened

        across R  sessions. ff files can be shared by multiple ff R objects  (using
        different

        data en/de-coding schemes) in the same process  or from multiple R processes
        to

        exploit parallelism. A wide choice of  finalizer options allows to work with
        ''''permanent''''

        files as well as  creating/removing ''''temporary'''' ff files completely
        transparent

        to the  user. On certain OS/Filesystem combinations, creating the ff files
        works

        without notable delay thanks to using sparse file allocation. Several access
        optimization

        techniques such as Hybrid Index  Preprocessing and Virtualization are implemented

        to achieve good  performance even with large datasets, for example virtual
        matrix  transpose

        without touching a single byte on disk. Further, to reduce  disk I/O, ''''logicals''''

        and non-standard data types get stored native and  compact on binary flat
        files

        i.e. logicals take up exactly 2 bits to  represent TRUE, FALSE and NA.  Beyond
        basic

        access functions, the ff package also provides  compatibility functions that
        facilitate

        writing code for ff and ram  objects and support for batch processing on ff
        objects

        (e.g. as.ram,  as.ff, ffapply). ff interfaces closely with functionality from
        package  ''''bit'''':

        chunked looping, fast bit operations and coercions between  different objects
        that

        can store subscript information (''''bit'''',  ''''bitwhich'''', ff ''''boolean'''',
        ri range

        index, hi hybrid index). This allows to work interactively with selections
        of large

        datasets and quickly  modify selection criteria.  Further high-performance
        enhancements

        can be made available upon request.

        '
extra:
    copy_test_source_files: true
    final: true
    recipe-maintainers:
        - bgruening
        - daler
        - jdblischak
        - johanneskoester
